<?php

require_once(dirname(__FILE__)."/../mapviewerphp/constants.php");

$sessionId = $_REQUEST["SESSION"];
$mapName = $_REQUEST["MAPNAME"];

try {
    MgInitializeWebTier(dirname(__FILE__)."/../webconfig.ini");
    $siteConn = new MgSiteConnection();
    $userInfo = new MgUserInformation($sessionId);
    $siteConn->Open($userInfo);
    
    //Let's modify the map with these desired parameters
    $dpi = 128;
    $centerX = -87.763435;
    $centerY = 43.761722;
    $scale = 5000;
    $width = 800;
    $height = 600;
    
    //Here's how we do it, setup a GETDYNAMICMAPOVERLAYIMAGE request and invoke
    //it with MgHttpRequest
    $req = new MgHttpRequest("");
    $reqParam = $req->GetRequestParam();
    $reqParam->AddParameter("OPERATION", "GETDYNAMICMAPOVERLAYIMAGE");
    $reqParam->AddParameter("VERSION", "2.0.0");
    $reqParam->AddParameter("LOCALE", "en");
    $reqParam->AddParameter("SESSION", $sessionId);
    $reqParam->AddParameter("MAPNAME", $mapName);
    $reqParam->AddParameter("SETVIEWCENTERX", $centerX);
    $reqParam->AddParameter("SETVIEWCENTERY", $centerY);
    $reqParam->AddParameter("SETVIEWSCALE", $scale);
    $reqParam->AddParameter("SETDISPLAYDPI", $dpi);
    $reqParam->AddParameter("SETDISPLAYWIDTH", $width);
    $reqParam->AddParameter("SETDISPLAYHEIGHT", $height);
    
    //This ensures the operation will be the speediest (as we really just want to modify MgMap properties
    //and not actually render an image from it). Selections only in the smallest image format
    $reqParam->AddParameter("BEHAVIOR", "1");
    $reqParam->AddParameter("FORMAT", "JPG");
    
    //This does the actual API invocation
    $response = $req->Execute();
    
    //All http requests have a result, we don't really care in this case but you can
    //inspect the result and the HTTP status code if you need to handle failures
    $result = $response->GetResult();
    
    //Now let's open a MgMap under that name and verify our results
    $map = new MgMap($siteConn);
    $map->Open($mapName);
    
    //Print out the values. They should match what we've set up above
    $center = $map->GetViewCenter();
    $centerCoord = $center->GetCoordinate();
    echo "<p>View Center X: ".$centerCoord->GetX()."</p>";
    echo "<p>View Center Y: ".$centerCoord->GetY()."</p>";
    echo "<p>View Scale: ".$map->GetViewScale()."</p>";
    echo "<p>DPI: ".$map->GetDisplayDpi()."</p>";
    echo "<p>Display Width: ".$map->GetDisplayWidth()."</p>";
    echo "<p>Display Height: ".$map->GetDisplayHeight()."</p>";
}
catch (MgException $ex) {
    echo "<strong>MapGuide Error:</strong><pre>".$ex->GetDetails()."</pre>";
    echo "<a href='index.php?SESSION=$sessionId&MAPNAME=$mapName'>Return</a>";
    die;
} catch (Exception $e) {
    echo "<strong>Error:</strong><pre>".$e->getMessage()."</pre>";
    echo "<a href='index.php?SESSION=$sessionId&MAPNAME=$mapName'>Return</a>";
    die;
}
?>